unit Renomear;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, Buttons;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    FileListBox: TFileListBox;
    DirectoryListBox: TDirectoryListBox;
    DriveComboBox: TDriveComboBox;
    FilterComboBox: TFilterComboBox;
    Renomeia: TSpeedButton;
    Sair: TSpeedButton;
    procedure SairClick(Sender: TObject);
    procedure RenomeiaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.SairClick(Sender: TObject);
begin
 close;
end;

function Trata_Arquivo ( Cabecalho : String; Corpo : String; Padrao : String ): String;
var
  Nome, Banco, Sequencia, Movimento, Auxiliar : String;
  I : Integer;
begin
   for I := 46 to 57 do
     Auxiliar := Auxiliar + Cabecalho[I];

    // Tratamento para descobrir o nome do banco ...
    if Auxiliar = 'BRADESCO S.A' then
     Banco := 'br'
    else if Auxiliar = 'BANCO BILBAO' then
     Banco := 'bi'
    else if Auxiliar = 'BANEB       ' then
     Banco := 'ba'
    else if Auxiliar = 'BANCO DO BRA' then
     Banco := 'bb'
    else if Auxiliar = 'BCO. ESTADO ' then
     Banco := 'bn'
    else if Auxiliar = 'CAIXA ECON. ' then
     Banco := 'cx'
    else if Auxiliar = 'HSBC BANK BR' then
     Banco := 'hs'
    else if Auxiliar = 'HSBC        ' then
     Banco := 'hs'
    else if Auxiliar = 'BANCO ITAU S' then
     Banco := 'it'
    else if Auxiliar = 'MERCANTIL DO' then
     Banco := 'me'
    else if Auxiliar = 'REAL        ' then
     Banco := 're'
    else if Auxiliar = 'SUDAMERIS   ' then
     Banco := 'su'
    else if Auxiliar = 'UNIBANCO    ' then
     Banco := 'un'
    else if Auxiliar = 'UNICRED CENT' then
     Banco := 'uc'
    else
     begin
      Trata_Arquivo := Padrao;
      exit;
     end;
    Nome := Banco;

   // Tratamento para descobrir se  dbito ou cdigo de barras ...
   // Sendo assim saber onde se encontra a data de movimento ...
   // E a extenso do arquivo ...
   if Cabecalho[81] = '3' then
   begin
    for I := 22 to 29 do
     Movimento := Movimento + Corpo[I];

    // Inverte data de movimento ...
    Auxiliar := '';
    Auxiliar := Movimento[7] + Movimento[8] + Movimento[5] + Movimento[6];
    for I := 1 to 4 do
     Auxiliar := Auxiliar + Movimento[I];

    Movimento := Auxiliar;

    Nome := Nome + Movimento + '.';

    // Verifica se  um arquivo Pr-Pago ...
    Auxiliar := '';
    for I := 38 to 41 do
     Auxiliar := Auxiliar + Cabecalho[I];

    // Atribue extenso ...

    if Auxiliar = 'PAGO' then
     Nome := Nome + 'pp.';
   end
   else
   begin
    if Corpo[1] = 'J' then
      for I := 39 to 46 do
       Movimento := Movimento + Corpo[I]
    else
      for I := 45 to 52 do
       Movimento := Movimento + Corpo[I];

    // Inverte data de movimento ...
    Auxiliar := '';
    Auxiliar := Movimento[7] + Movimento[8] + Movimento[5] + Movimento[6];
    for I := 1 to 4 do
     Auxiliar := Auxiliar + Movimento[I];

    Movimento := Auxiliar;

    Nome := Nome + Movimento + '.da.';
   end;

   // Tratamento para descobrir a sequncia ...
   for I := 77 to 79 do
     Sequencia := Sequencia + Cabecalho[I];

   Nome := Nome + Sequencia;

   Trata_Arquivo := Nome;
end;

procedure TForm1.RenomeiaClick(Sender: TObject);
var
   Qte, I, Contador : Integer;
   Arquivo : TextFile;
   Nome_Arquivo, Cabecalho, Corpo : String;
begin
 Contador := 0;
 Qte := FileListBox.Items.Count;
 For I:= 0 to Qte do
  begin
   if FileListBox.Selected[I] = True then
    begin
      AssignFile ( Arquivo,FileListBox.Items.Strings[I] );
      Reset ( Arquivo );
      Readln ( Arquivo,Cabecalho );
      Read ( Arquivo,Corpo );
      CloseFile( Arquivo );
      Nome_Arquivo := Trata_Arquivo ( Cabecalho, Corpo, FileListBox.Items.Strings[I]  );
      Rename ( Arquivo, Nome_Arquivo );
      Contador := Contador + 1;
    end;
   if Contador = FileListBox.SelCount then
    break;
  end;
  ShowMessage('Quantidade de arquivos renomeados - '+ IntToStr(Contador));
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
 DriveComboBox.Drive:= 'C';
end;

end.
